#include <SPI.h>
#include <BLEPeripheral.h>
#include <BLEHIDPeripheral.h>
#include "BLETrackBall.h"

#include <Wire.h>

#include <Tle493d_w2b6.h>

BLEHIDPeripheral bleHIDPeripheral = BLEHIDPeripheral(-1. -1. -1);
BLETrackBall BLETrackBall;


Tle493d_w2b6 Tle493dMagnetic3DSensor = Tle493d_w2b6();

void setup() {
  bleHIDPeripheral.setDeviceName("Magnetic TrackBall");
  bleHIDPeripheral.setLocalName("Magnetic TrackBall");
  bleHIDPeripheral.setReportIdOffset(1);
  bleHIDPeripheral.addHID(BLETrackBall);  
  
  bleHIDPeripheral.clearBondStoreData();
  
  bleHIDPeripheral.begin();  

  Wire.setPins(9, 3);
  Wire.setClock(100000);
  Wire.begin();
  
  Tle493dMagnetic3DSensor.begin();
  Tle493dMagnetic3DSensor.enableTemp();
}

void loop() {
  BLECentral central = bleHIDPeripheral.central();
  if (central) {        
    int8_t x = 0, y = 0, z = 0, rx = 0, ry = 0, rz = 0;
    while (central.connected()) {
      
    Tle493d_w2b6_Error_t result = Tle493dMagnetic3DSensor.updateData();
    if (result != Tle493d_w2b6_Error::TLE493D_W2B6_NO_ERROR) {        
        //Tle493dMagnetic3DSensor.resetSensor();
        //delay(50);      
        //continue;
    }
        
    rx = (int8_t) Tle493dMagnetic3DSensor.getX();
    ry = (int8_t) Tle493dMagnetic3DSensor.getY(); 
    rz = (int8_t) Tle493dMagnetic3DSensor.getZ();
    
    BLETrackBall.move(x, y, z, rx, ry, rz);
    delay(200);
    }  
  }
    
  delay(50);
}
